;*
;********************  *************************************
;*
;*  ATtiny13A, RC -  4,8 
;*    - 75 
;*
;* Main:           
;*
;* SPI_prog:          74HC164
;* Measure_BAT:       
;* Cap_Bat:          
;* DIV42:          
;* Volt_L:           
;* Cons_VoltL:       
;* Divide10:         ,  
;* Wait_2:	        2,0 
;* Wait_02:	        0,2 
;*
;* Fuses          CKSEL=01, BODLEVEL=01
;*                  ,    0.
;****************************************************************************

.nolist
.include "tn13def.inc"
.list

;***** *****

.def	m0 = r1        ;  / 
.def	m1 = r2     
.def	m2 = r3      
.def	m3 = r4      
.def	m4 = r5      
.def	m5 = r6      
.def	m6 = r7       
.def	m7 = r8       

.def	t1	 = r16     ;   
.def	t2	 = r17     ;   

.def	Cnt =  r19     ;   
.def	Output = r20   ;   
.def	CompL = r21    ;  ,  
.def	CompH = r22    ;  ,  
.def	spi_data = r23 ;  
.def	tim1 = r25     ;   

             

;*****  *****

.equ  ADSM = 0b11001110  ; ADEN,ADSC,ADATE,ADIF,ADIE,ADPS2=1,ADPS1=1,ADPS0=0
.equ  ADMX = 0b01000010  ; REFS0=1,Vref=1,1V,ADC2-  

.equ  mosi = PB2         ;   74HC164
.equ  clk = PB3          ;  74HC164


.cseg

.org 0
	rjmp Initial


.org 9               ;    ADC Complete
ldi   t1,(1<<SM0)        ; SE=0 ( "" ), SM1=1,SM0=1
out   MCUCR,t1           ; ""  =  
reti

Initial: ;  
	
    ldi   t1,(RamEnd)
    out   spl,t1	    ;  
	
   	ldi	t1,0b00000011  
	out	PORTB,t1        ; PB0- SB1,PB1- Error (LED9)
	ldi	t1,0b00001110	; PB2- mosi, PB3- clk, PB4- ADC2 	
	out	DDRB,t1		     

ldi   t1,ADMX           ;       
out   ADMUX,t1    	    

ldi  t1,0               ;    T0
out  TCNT0,t1
ldi t1,(1<<CS02)|(1<<CS00);     CK/1024 = 4687,5 Hz
out TCCR0B,t1

ldi spi_data,0      ;  
cbi PORTB,1         ;    
rcall SPI_prog
rcall Wait_1    	;   1,0 

sei                 ;  

Main:  ;  

clr Output
ldi spi_data,$FF    ;  
rcall SPI_prog
sbi PORTB,1         ;   
clr  t1
in  t1,PINB         ;    SB1
sbrc t1,0           ;   ,  0
rcall Measure_BAT   ;     
rjmp Main

Wait_2:	;   2,0 
ldi   t1,0	        ;   
out   TCNT0,t1   	;  T/C0
ldi   t1,1<<TOV0	;     TOV0
out   TIFR0,t1      ;   TOV0
ldi   tim1,37       ; 37   
Wait:
in    t1,TIFR0      ;    TIFR
sbrs  t1,TOV0;   ,    
rjmp  Wait	        ;   
ldi   t1,1<<TOV0	;     TOV0
out   TIFR0,t1      ;   TOV0
dec   tim1
brne  Wait	        ; 37  = 2,0 
ret

Wait_1:	;   1,0 
ldi   t1,0	        ;   
out   TCNT0,t1   	;  T/C0
ldi   t1,1<<TOV0	;     TOV0
out   TIFR0,t1      ;   TOV0
ldi   tim1,18       ; 18   
Wait2:
in    t1,TIFR0      ;    TIFR
sbrs  t1,TOV0;   ,    
rjmp  Wait2	        ;   
ldi   t1,1<<TOV0	;     TOV0
out   TIFR0,t1      ;   TOV0
dec   tim1
brne  Wait2	        ; 18  = 1,0 
ret

Wait_02:	;   0,2 
ldi   t1,0	        ;   
out   TCNT0,t1   	;  T/C0
ldi   t1,1<<TOV0	;     TOV0
out   TIFR0,t1      ;   TOV0
ldi   tim1,4        ; 4   
Wait1:
in    t1,TIFR0      ;    TIFR
sbrs  t1,TOV0;   ,    
rjmp  Wait1	        ;   
ldi   t1,1<<TOV0	;     TOV0
out   TIFR0,t1      ;   TOV0
dec   tim1
brne  Wait1	        ; 4  = 0,2 
ret

SPI_prog: ;     74HC164

ldi Cnt,8         ;   
SPI_prog1:        
lsl spi_data      ;    
brcc low_mosi     ; ,  C=0
sbi PORTB,mosi    ;    1
rjmp clk_high     ; ,   
low_mosi:
cbi PORTB,mosi    ;    0
nop
clk_high:;
sbi PORTB,clk     ;   clk
nop
clk_low:
cbi PORTB,clk     ;   clk
nop
dec Cnt           ;   
brne SPI_prog1    ;  ,  Cnt   0
sbi PORTB,mosi    ;  , MOSI=1
ret

Measure_BAT: ;     

rcall Wait_02   	;    ""  SB1
rcall Wait_02   	 
clr m4              ;  
clr m5 
clr Cnt
MB0:
ldi   t1,ADSM       ;      
out   ADCSRA,t1
ldi  t1,(1<<SE)|(1<<SM0);  "" 
out  MCUCR,t1       
sleep               ;   
in   CompL,ADCL     ;   -
in   CompH,ADCH     ;   -
ldi  t1,0b01000111  ;   
out  ADCSRA,t1
add m4,CompL        ;   
adc m5,CompH
rcall Wait_02   	;   0,2 
inc Cnt             ;    
cpi Cnt,10          ;   10,    
breq Divide10
rjmp MB0            ;  

Divide10:   ;    ,  

clr m1              ;  
clr m6
clr m7
ldi t1,10           ;  
mov m0,t1
rcall DIV42         ;   
mov CompL,m4        ;     
mov CompH,m5
rcall Cap_Bat       ;    
rcall SPI_prog      ;     74HC164
cpi Output,7        ;    =20%,   
breq MB1
rcall Wait_1    	;   1,0 
rcall Wait_2    	;   2,0 
MB1:
ret

Cap_Bat:  ;    

ldi t2,3
cpi CompH,3
brlo Low_Cap    ; ,   CompH  3
ldi t2,0
CB0:
rcall Volt_L    ;    
cp CompL,r0     ;      
brsh CB1        ; ,  CompL     r0
inc t2
rjmp CB0
CB1:              ;   
cpi t2,0
breq CB100
cpi t2,1
breq CB85
cpi t2,2
breq CB70
CB100:           
ldi spi_data,0          ;   100%
ret
CB85:
ldi spi_data,1          ;   85%
ret
CB70:
ldi spi_data,3  		;   70%
ret
CB55:
ldi spi_data,7  		;   55%
ret
CB40:
ldi spi_data,$0F		;   40%
ret
CB25:
ldi spi_data,$1F		;   25%
ret
CB10:
ldi spi_data,$3F		;   10%
ret
CB00:
ldi spi_data,$7F		;   0%
ret

Low_Cap:
cpi CompH,2
brlo Error      ; ,   CompH  2
cpi CompL,$7F
brlo Error      ; ,   CompL  $7F (<1,0 V)
CB2:
rcall Volt_L    ;    
cp CompL,r0     ;      
brsh CB3        ; ,  CompL     r0
inc t2
rjmp CB2
CB3:              ;   
cpi t2,3
breq CB55
cpi t2,4
breq CB40
cpi t2,5
breq CB25
cpi t2,6
breq CB10
cpi t2,7
breq CB00
Error:
ldi spi_data,$FF  ;     1 
cbi PORTB,1       ;    
ret

DIV42:      ;  

ldi  t1,0x10

DCLK42:             ;   m7:m6:m5:m4
clc                 ;   m1:m0
mov  t2,m4          ;   m5:m4
rol  t2
mov  m4,t2
mov  t2,m5
rol  t2
mov  m5,t2
mov  t2,m6
rol  t2
mov  m6,t2
mov  t2,m7
rol  t2
mov  m7,t2
in   Cnt,SREG
push Cnt
PER1:
clc
mov  t2,m6
sbc  t2,m0
mov  m6,t2
mov  t2,m7
sbc  t2,m1
mov  m7,t2
brcs PER2
pop  Cnt
out  SREG,Cnt
PER3:
inc m4
rjmp PER4
PER2:
pop  Cnt
out  SREG,Cnt
brcs PER3
mov  t2,m6
add  t2,m0
mov  m6,t2
mov  t2,m7
adc  t2,m1
mov  m7,t2
PER4:
dec  t1
cpi  t1,0
brne DCLK42
ret

Volt_L:    ;    

ldi zl,Low(Cons_VoltL<<1)  ;    Z 
ldi zh,High(Cons_VoltL<<1) ;    
clr t1
add zl,t2              ;    
adc zh,t1
lpm                    ;  -  r0
ret

Cons_VoltL: ;    

.db $A3,$39 	; 1,50V, 1,33V
.db $14,$FB 	; 1,27V, 1,23V
.db $E2,$CA     ; 1,19V, 1,15V	
.db $B1,$7F     ; 1,11V, 1,03V

     

;**********************************************************************************
.Exit
